<template lang="pug">
  .export(:class="{ mobile: isMobile }")
    .content(v-if="!isLoading && !isProgress")
      .title
        .text Photoshop
        .is-payment(v-if="!isLicenseVerified || !isActiveLicense") PRO
        .description Objects in layers
      .sizes
        .size(
          v-for="(size, index) in sizesData"
          v-if="size.exportEntities.includes(EXPORT_ENTITY_PSD)"
          v-on:click="checkAndSave(EXPORT_ENTITY_PSD, size)"
          v-bind:class="{ 'is-current': size.isCurrent }"
        )
          .data
            .data-title
              div {{ size.title }}
              .spacer
              .export-icon
                .icon(v-html="$icons.arrowDown")
            .data-description {{ size.description }}
        .payment-lock(v-if="!isLicenseVerified || !isActiveLicense")
          a.button(href="https://icons8.com/buy" target="_blank")
            span.icon(v-html="$icons.lock")
            span Unlock for&nbsp;
            strong $20/month
      .title
        .text PNG
        .description Flat image
      .sizes
        .size(
          v-for="size in sizesData"
          v-if="size.exportEntities.includes(EXPORT_ENTITY_PNG)"
          v-on:click="checkAndSave(EXPORT_ENTITY_PNG, size)"
          v-bind:class="{ 'is-current': size.isCurrent }"
        )
          .data
            .data-title
              div {{ size.title }}
              .spacer
              .export-icon
                .icon(v-html="$icons.arrowDown")
            .data-description {{ size.description }}
      template(v-if="userCollage")
        .title
          .text Share
        .collage-url
          input.share(id="collageUrl" v-model="shareUrl" readonly tabindex="-1")
          .copy-shadow
          button.copy(@click="copy" tabindex="-1") Copy
        share(:shareUrl="shareUrl")
      .spacer
      .public
        .icon(v-html="$icons.heart")
        .info
          | We share the best collages&nbsp;
          a(
            href='https://photos.icons8.com/category--collages-5b3218def0fed70021ccb63b'
            target='_blank'
            tabindex="-1"
          ) here
          | ,&nbsp;
          br(v-if="!isMobile")
          | so your work might be public.
    template(v-else)
      .progress-container
        .loading-block(v-if="isLoading")
          .loader
          .export-title {{ getExportTitle() }}
        .progress-block(
          v-if="isProgress"
          v-bind:class="{ done: progress === 100 }"
        )
          .c100(ref="progress")
            span(v-if="progress !== 100") {{ progress }}%
            span.icon(
              v-else
              v-html="$icons.okLight"
            )
            .slice
              .bar
              .fill
          .export-title {{ description }}
          .cancel-button(
            v-if="!error && (exportingEntity === EXPORT_ENTITY_PSD && progress !== 100)"
            v-on:click="cancel()"
          ) Cancel
        .error(v-if="error") {{ error }}
        .warning(v-if="progress === 100 && warning")
          div Warning:
          div {{ warning }}
        .close-progress-button(
          v-if="error"
          v-on:click="stop()"
        ) Close
</template>

<script>
import { mapState } from 'vuex'

import dataService from '../../services/data'
import stageService from '../../services/stage'
import photosApi from '../../api/photos'
import config from '../../config'

const EXPORT_ENTITY_PSD = 'PSD'
const EXPORT_ENTITY_PNG = 'PNG'

const ERROR_MESSAGE = 'Oops... There is some error occured. Please try again later.'

export default {
  name: 'Export',
  data: function () {
    return {
      isLoading: false,
      isProgress: false,
      exportingEntity: null,
      EXPORT_ENTITY_PSD,
      EXPORT_ENTITY_PNG,
      filename: 'download.psd',
      progress: 0,
      error: null,
      warning: null,
      description: null,
      toDownload: null,
      sizesData: [
        {
          title: 'S',
          greaterSideWidth: Math.ceil((config.stage.sideMaxWidth / 3) / 100) * 100,
          description: '',
          isCurrent: false,
          exportEntities: [
            EXPORT_ENTITY_PSD,
            EXPORT_ENTITY_PNG
          ]
        },
        {
          title: 'M',
          greaterSideWidth: Math.ceil((config.stage.sideMaxWidth / 3 * 2) / 100) * 100,
          description: '',
          isCurrent: false,
          exportEntities: [
            EXPORT_ENTITY_PSD,
            EXPORT_ENTITY_PNG
          ]
        },
        {
          title: 'L',
          greaterSideWidth: config.stage.sideMaxWidth,
          description: '',
          isCurrent: false,
          exportEntities: [
            EXPORT_ENTITY_PSD
          ]
        }
      ]
    }
  },
  computed: {
    ...mapState({
      stageRealWidth: state => state.editor.stage.realWidth,
      stageRealHeight: state => state.editor.stage.realHeight,
      stageGreaterSideWidth: state => state.editor.stage.realWidth > state.editor.stage.realHeight ? state.editor.stage.realWidth : state.editor.stage.realHeight,
      isActiveLicense: state => state.editor.user && state.editor.user.license && !state.editor.user.license.expired,
      isLicenseVerified: state => state.editor.licenseVerified,
      userCollage: state => state.editor.userCollage,
      isMobile: state => state.editor.isMobile
    }),
    shareUrl () {
      if (this.userCollage) {
        return process.env.host + '/creator/photo/' + this.userCollage.id
      }
      return null
    }
  },
  watch: {
    stageRealWidth () {
      this.getSizeDescription()
    }
  },
  mounted () {
    this.getSizeDescription()
  },
  methods: {
    checkAndSave (entity, size) {
      if (!(entity === this.EXPORT_ENTITY_PSD && (!this.isLicenseVerified || !this.isActiveLicense))) {
        this.toDownload = { entity, size }
        this.download()
        if (this.userCollage) {
          photosApi.saveUserCollage({ collage: { exported: true } }, this.userCollage.id)
            .then((collage) => {
              this.$store.dispatch('userCollageSet', dataService.handleCollage(collage))
            })
        }
      }
    },
    download () {
      if (this.toDownload) {
        switch (this.toDownload.entity) {
          case EXPORT_ENTITY_PSD:
            this.psdDownload(this.toDownload.size)
            break
          case EXPORT_ENTITY_PNG:
            this.pngDownload(this.toDownload.size)
            break
        }
        this.toDownload = null
      }
    },
    psdDownload (size) {
      this.exportingEntity = EXPORT_ENTITY_PSD
      new Promise((resolve, reject) => {
        this.error = null
        this.warning = null
        this.progress = 0
        this.isProgress = true
        this.description = this.getExportTitle()
        this.$connect()
        this.$socket.onopen = () => {
          const greaterSideWidth = size.isCurrent ? this.stageGreaterSideWidth : size.greaterSideWidth
          const json = { 'command': 'generatePSD', 'properties': dataService.getStageData(false, greaterSideWidth, false) }
          this.$socket.sendObj(json)
          this.$options.sockets.onmessage = messageEvent => {
            const data = JSON.parse(messageEvent.data)

            if (data.error) {
              this.$disconnect()
              reject(data.error || data.warning)
            } else if (data.warning) {
              this.warning = data.warning
            } else {
              this.progress = data.properties.progress
              this.description = data.properties.description

              // Add css class to show progress
              this.$refs.progress.classList.forEach(className => {
                if (/p\d{1,3}/.test(className)) {
                  this.$refs.progress.classList.remove(className)
                }
                this.$refs.progress.classList.add(`p${this.progress}`)
              })

              if (data.properties.progress === 100) {
                const link = document.createElement('a')
                link.href = `${data.properties.url.replace('/assets/', '/high-res/assets/')}?filename=${this.filename}`
                document.body.appendChild(link)
                link.click()
                document.body.removeChild(link)

                this.$disconnect()
                resolve()
              }
            }
          }
        }
        this.$socket.onclose = () => {
          delete this.$options.sockets.onmessage
        }
        this.$socket.onerror = (error) => {
          this.$disconnect()
          console.log(error)
        }
      })
        .then(() => {
          setTimeout(() => {
            this.isProgress = false
          }, 3000)
        })
        .catch(error => {
          console.log(error)
          this.error = ERROR_MESSAGE
        })
    },
    pngDownload (size) {
      this.isLoading = true
      this.error = null
      this.warning = null
      this.exportingEntity = EXPORT_ENTITY_PNG
      this.$nextTick(() => {
        stageService.download(size.isCurrent ? this.stageGreaterSideWidth : size.greaterSideWidth)
          .then(() => {
            this.isLoading = false
          })
          .catch(() => {
            this.error = ERROR_MESSAGE
          })
      })
    },
    getSizeDescription () {
      if (this.stageGreaterSideWidth) {
        this.sizesData.forEach((size, index) => {
          let sizeFrom, sizeTo
          let maxSideRatio = 1
          let isPreviousConditionMeet = false

          // Resolve left condition (more than)
          if (index === 0 && this.stageGreaterSideWidth >= 0) {
            isPreviousConditionMeet = true
          } else if (this.stageGreaterSideWidth >= this.sizesData[index - 1].greaterSideWidth) {
            isPreviousConditionMeet = true
          }

          const isCurrent = isPreviousConditionMeet && this.stageGreaterSideWidth <= size.greaterSideWidth
          if (!isCurrent) {
            maxSideRatio = this.sizesData[index].greaterSideWidth / this.stageGreaterSideWidth
          }

          sizeFrom = Math.ceil(this.stageRealWidth * maxSideRatio)
          sizeTo = Math.ceil(this.stageRealHeight * maxSideRatio)
          size.isCurrent = isCurrent
          size.description = `${sizeFrom}x${sizeTo}`
        })
      }
    },
    stop () {
      this.isProgress = false
      this.isLoading = false
    },
    getExportTitle () {
      switch (this.exportingEntity) {
        case EXPORT_ENTITY_PSD:
          return 'Prepairing...'
        case EXPORT_ENTITY_PNG:
          return 'Generating PNG file...'
      }
    },
    cancel () {
      this.$disconnect()
      this.isProgress = false
    },
    copy () {
      const input = document.getElementById('collageUrl')
      input.select()
      document.execCommand('copy')
      setTimeout(() => {
        window.getSelection().removeAllRanges()
      }, 250)
    }
  }
}
</script>

<style lang="scss" scoped>
@import '../../assets/css/variables';
@import '../../assets/css/progress';
@import '../../assets/css/mixins';

.export {
  width: 100%;
  height: 100%;
  overflow-x: hidden;

  .scroll-container {
    width: 100%;
    height: 100%;

    /deep/ .simplebar-content {
      display: flex;
    }

    /deep/ .simplebar-scrollbar:before {
      background-color: #cacaca;
    }
  }

  .content {
    height: calc(100vh - 54px);
    display: flex;
    flex-direction: column;
    padding: 0 20px;

    .title {
      display: flex;
      align-items: flex-end;
      padding: 32px 4px 0 4px;

      .text {
        font-size: 24px;
        line-height: 24px;
        font-weight: bold;
        text-transform: uppercase;
      }

      .is-payment {
        background: #0CA940;
        font-size: 10px;
        border-radius: 100px;
        padding: 4px 8px;
        margin-left: 8px;
      }

      .description {
        font-size: 14px;
        line-height: 14px;
        color: rgba(255, 255, 255, 0.5);
        padding-left: 12px;
      }
    }

    .collage-url {
      margin: 24px 4px;
    }

    .collage-url, .sizes {
      display: flex;
      flex-direction: row;
      position: relative;
      z-index: 10;
      margin-top: 24px;
    }

    .sizes {
      .size {
        width: 110px;
        height: 80px;
        display: flex;
        flex-direction: column;
        padding: 8px 8px 8px 12px;
        background-color: rgba(255, 255, 255, 0.10);
        margin: 4px;
        border-radius: 8px;
        cursor: pointer;

        &.is-current {
          background-color: rgba(255, 255, 255, 0.2);
        }

        .data {
          &-title {
            width: 100%;
            display: flex;
            flex-direction: row;
            align-items: center;
            font-size: 24px;
            font-weight: bold;
          }

          &-description {
            color: rgba(255, 255, 255, 0.5);
            font-size: 14px;
            padding-top: 8px;
          }
        }

        .export-icon {
          width: 23px;
          height: 23px;
          border: 2px solid rgba(255, 255, 255, 0.5);
          border-radius: 24px;
          display: none;
          align-items: center;
          justify-content: center;

          .icon {
            width: 9px;
            height: 30px;
            fill: rgba(255, 255, 255, 0.5);
          }
        }

        &:hover, &.active {
          transition: all 0.5s;
          background-color: rgba(255, 255, 255, 0.15);

          .export-icon {
            display: flex;
          }
        }
      }

      .payment-lock {
        width: 100%;
        height: 100%;
        display: flex;
        flex-direction: row;
        align-items: center;
        justify-content: center;
        position: absolute;
        z-index: 10;
        background-color: rgba(33, 33, 33, 0.7);

        .button {
          padding: 12px 16px;

          .icon {
            width: 14px;
            height: 18px;
            margin-right: 8px;
          }
        }
      }
    }
  }

  .progress-container {
    width: 100%;
    height: calc(100% - 56px);
    height: calc(var(--vh, 1vh) * 100 - 56px);
    display: flex;
    flex-direction: column;
    align-items: center;
    justify-content: center;

    .loading-block, .progress-block {
      display: flex;
      flex-direction: column;
      align-items: center;
      justify-content: center;

      .loader {
        width: 56px;
        height: 56px;
        position: relative;
        @include loading(#fff, 4px, 56px);
      }

      .export-title {
        max-width: 200px;
        padding: 24px 0;
        text-align: center;
        color: rgba(255, 255, 255, 0.5);
        font-size: 14px;
        text-transform: uppercase;
      }
    }

    .error {
      max-width: 220px;
      color: #ff7171;
      padding: 0 0 24px 0;
      text-align: center;
    }

    .warning {
      display: flex;
      flex-direction: column;
      align-items: center;
      color: rgba(255, 255, 255, 0.3);
    }

    .cancel-button, .close-progress-button {
      width: 96px;
      text-align: center;
      border-radius: 10px;
      padding: 8px 24px;
      font-size: 14px;
      color: #fff;
      background-color: rgba(255, 255, 255, 0.1);
      cursor: pointer;

      &:hover {
        background-color: rgba(255, 255, 255, 0.05);
      }
    }

    .progress-block {
      display: flex;
      flex-direction: column;
      align-items: center;

      &.done {
        .c100.p100 .bar, .c100.p100 .fill {
          border-color: #4AC144;
        }

        .export-title {
          color: #fff;
        }
      }

      .icon {
        width: 37px;
        height: 25px;
        stroke: #4AC144;
        left: calc(50% - 19px);
        top: calc(50% - 13px);
      }
    }
  }

  .share {
    background: rgba(255, 255, 255, .1);
    border-radius: 10px;
    border: 0;
    outline: 0;
    width: 100%;
    line-height: normal;
    font-size: 14px;
    color: #fff;
    padding: 0 74px 0 16px;
    height: 56px;
  }

  .copy {
    position: absolute;
    right: 0;
    height: 56px;
    background: transparent;
    border: 0;
    outline: 0;
    border-radius: 8px;
    color: #fff;
    line-height: normal;
    font-size: 14px;
    padding: 0 24px 0 0;
    cursor: pointer;

    &-shadow {
      position: absolute;
      right: 56px;
      background: linear-gradient(270deg, #373737 33.04%, rgba(55, 55, 55, 0) 100%);
      width: 56px;
      height: 56px;
    }
  }

  .public {
    border: 1px solid rgba(255, 255, 255, .1);
    color: #909090;
    border-radius: 8px;
    margin: 30px 0 20px 0;
    padding: 20px;
    display: flex;

    .icon {
      width: 42px;
      height: 42px;
      display: flex;
      flex: 0 0 38px;
      margin-right: 20px;
    }

    .info {
      font-size: 15px;
      line-height: 21px;

      a {
        color: #fff;
        text-decoration: none;
      }
    }
  }

  &.mobile {
    .content {
      padding: 0 8px 12px 8px;

      .title {
        padding: 16px 4px 0 4px;
      }

      .sizes {
        margin-top: 8px;

        .size {
          width: calc(33.33% - 8px);
        }
      }

      .public {
        margin: 30px 4px 0 4px;
      }
    }
  }
}
</style>
